from pyfbsdk import *
from pyfbsdk_additions import *
from file import *
from elements import *
from characters import *

#FILE FUNCTIONS
def fileNewCallback(control, event):
    fileNew()
def fileOpenCallback(control, event):
    fileOpen()
def fileSaveCallback(control, event):
    fileSave()
def fileSaveAsCallback(control, event):
    fileSaveAs()

#ELEMENT FUNCTIONS
def threedcurveCallback(control, event):
    threedcurve()
def cameraCallback(control, event):
    camera()
def cubeCallback(control, event):
    cube()
def handleCallback(control, event):
    handle()
def lightCallback(control, event):
    light()
def markerCallback(control, event):
    marker()
def noteCallback(control, event):
    note()
def nullCallback(control, event):
    null()
def opticalCallback(control, event):
    optical()
def planeCallback(control, event):
    plane()
def skeletonNodeCallback(control, event):
    skeletonNode()
def skeletonRootCallback(control, event):
    skeletonRoot()  
    
#CHARACTER FUNCTIONS   
def actorCallback(control, event):
    actor()
def actorFaceCallback(control, event):
    actorFace()
def characterCallback(control, event):
    character()
def characterExtensionCallback(control, event):
    characterExtension()
def characterFaceCallback(control, event):
    characterFace()                                           

#PRIMITIVES FUNCTIONS   
def actorCallback(control, event):
    actor()
def actorFaceCallback(control, event):
    actorFace()
def characterCallback(control, event):
    character()
def characterExtensionCallback(control, event):
    characterExtension()
def characterFaceCallback(control, event):
    characterFace()   

def PopulateLayout(mainLyt):
    tab = FBTabControl()
        
    # insert tab control
    x = FBAddRegionParam(0,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachTop,"")
    w = FBAddRegionParam(-5,FBAttachType.kFBAttachRight,"")
    h = FBAddRegionParam(-5,FBAttachType.kFBAttachBottom,"")
    
    mainLyt.AddRegion("tab", "tab",x,y,w,h)
    mainLyt.SetControl("tab", tab)

    # TAB 1:: File

    #This is the container inside tab 1...
    l = FBLayout()                
    x = FBAddRegionParam(0,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"")
    w = FBAddRegionParam(0,FBAttachType.kFBAttachRight,"")
    h = FBAddRegionParam(0,FBAttachType.kFBAttachTop,"")
    l.AddRegion("File","File", x, y, w, h)    
    
    #FILE NEW BUTTON
    fileNew = FBButton()
    fileNew.Style = FBButtonStyle.kFBBitmapButton
    fileNew.SetImageFileNames ("python/newScript.tif") 
    fileNew.Hint = "New File"
    
    x = FBAddRegionParam(0,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"File")
    w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    l.AddRegion("FileNew","FileNew", x, y, w, h)
    l.SetControl("FileNew",fileNew)
    fileNew.OnClick.Add(fileNewCallback)
    
    #FILE OPEN BUTTON
    fileOpen = FBButton()
    fileOpen.Style = FBButtonStyle.kFBBitmapButton
    fileOpen.SetImageFileNames ("python/openScript.tif") 
    fileOpen.Hint = "Open..."
    
    x = FBAddRegionParam(40,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"File")
    w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    l.AddRegion("FileOpen","FileOpen", x, y, w, h)
    l.SetControl("FileOpen",fileOpen)    
    fileOpen.OnClick.Add(fileOpenCallback)
       
    #FILE SAVE BUTTON
    fileSave = FBButton()
    fileSave.Style = FBButtonStyle.kFBBitmapButton
    fileSave.SetImageFileNames ("python/saveScript.tif") 
    fileSave.Hint = "Save..."
    
    x = FBAddRegionParam(80,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"File")
    w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    l.AddRegion("FileSave","FileSave", x, y, w, h)
    l.SetControl("FileSave",fileSave)
    fileSave.OnClick.Add(fileSaveCallback)         

    #FILE SAVE AS BUTTON
    fileSaveAs = FBButton()
    fileSaveAs.Style = FBButtonStyle.kFBBitmapButton
    fileSaveAs.SetImageFileNames ("python/executeScript.tif") 
    fileSaveAs.Hint = "Save As..."
    
    x = FBAddRegionParam(120,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"File")
    w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
    l.AddRegion("FileSaveAs","FileSaveAs", x, y, w, h)
    l.SetControl("FileSaveAs",fileSaveAs)  
    fileSaveAs.OnClick.Add(fileSaveAsCallback)    
    
    #Last but not least add the layout to the tab
    tab.Add("File",l) # Actually adds the tab you have just layed out to the UI 
    
    # TAB 2:: Elements
    l = FBLayout()              
    x = FBAddRegionParam(0,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"")
    w = FBAddRegionParam(0,FBAttachType.kFBAttachRight,"")
    h = FBAddRegionParam(0,FBAttachType.kFBAttachTop,"")
    l.AddRegion("Elements","Elements", x, y, w, h)    
    
    elements = ["3D Curve", "Camera", "Cube", "Handle", "Light", "Marker", "Note", "Null", "Optical", "Plane", "Skeleton node", "Skeleton root"]
    j = 0
    count = len(elements)
    for i in elements:
        button = FBButton()
        button.Style = FBButtonStyle.kFBBitmapButton
        if i == "Note":
            button.SetImageFileNames ("browsing/template_" + i + "-l.tif") 
        else:
            button.SetImageFileNames ("browsing/template_model_" + i + "-l.tif") 
        button.Hint = i
        
        x = FBAddRegionParam(j*40,FBAttachType.kFBAttachLeft,"")
        y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"Elements")
        w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
        h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
        l.AddRegion(i,i, x, y, w, h)
        l.SetControl(i,button)
        if i == "3D Curve":
            button.OnClick.Add(threedcurveCallback)
        elif i == "Camera":
            button.OnClick.Add(cameraCallback)            
        elif i == "Cube":
            button.OnClick.Add(cubeCallback)
        elif i == "Handle":
            button.OnClick.Add(handleCallback)        
        elif i == "Light":
            button.OnClick.Add(lightCallback)
        elif i == "Marker":
            button.OnClick.Add(markerCallback)
        elif i == "Note":
            button.OnClick.Add(noteCallback)
        elif i == "Null":
            button.OnClick.Add(nullCallback)
        elif i == "Optical":
            button.OnClick.Add(opticalCallback)
        elif i == "Plane":
            button.OnClick.Add(planeCallback)
        elif i == "Skeleton node":
            button.OnClick.Add(skeletonNodeCallback)
        else:
            button.OnClick.Add(skeletonRootCallback)                                                                                                
        j = j+1
    
    tab.Add("Elements",l) # Actually adds the tab you have just layed out to the UI

    # TAB 3:: Primitives    
    l = FBLayout()              
    x = FBAddRegionParam(0,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"")
    w = FBAddRegionParam(0,FBAttachType.kFBAttachRight,"")
    h = FBAddRegionParam(0,FBAttachType.kFBAttachTop,"")
    l.AddRegion("primatives","Primitives", x, y, w, h)

    primatives = ["Cone", "Cube", "Cylinder", "Disc", "Plane", "Sphere", "Torus"]
    j = 0
    count = len(primatives)
    for i in primatives:
        button = FBButton()
        button.Style = FBButtonStyle.kFBBitmapButton
        button.SetImageFileNames ("primitives/" + i + "-l.tif") 
        button.Hint = i
        
        x = FBAddRegionParam(j*40,FBAttachType.kFBAttachLeft,"")
        y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"primatives")
        w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
        h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
        l.AddRegion(i,i, x, y, w, h)
        l.SetControl(i,button)
        if i == "Cone":
            button.OnClick.Add(cubeCallback)
        elif i == "Cube":
            button.OnClick.Add(cubeCallback)            
        elif i == "Cylinder":
            button.OnClick.Add(cubeCallback)
        elif i == "Disc":
            button.OnClick.Add(handleCallback)        
        elif i == "Plane":
            button.OnClick.Add(lightCallback)
        elif i == "Sphere":
            button.OnClick.Add(markerCallback)
        elif i == "Torus":
            button.OnClick.Add(noteCallback)
        j = j+1

    tab.Add("Primitives",l) # Actually adds the tab you have just layed out to the UI
    
    # TAB 4:: Characters
    l = FBLayout()              
    x = FBAddRegionParam(0,FBAttachType.kFBAttachLeft,"")
    y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"")
    w = FBAddRegionParam(0,FBAttachType.kFBAttachRight,"")
    h = FBAddRegionParam(0,FBAttachType.kFBAttachTop,"")
    l.AddRegion("Characters","Characters", x, y, w, h)    
    
    char = ["Actor", "Actor face", "Character", "Character Extension", "Character face"]
    j = 0
    count = len(char)
    for i in char:
        button = FBButton()
        button.Style = FBButtonStyle.kFBBitmapButton
        if i == "Actor face":
            button.SetImageFileNames ("browsing/template_character_actorface-l.tif") 
        elif i == "Character Extension":
            button.SetImageFileNames ("browsing/template_character_extension-l.tif") 
        elif i == "Character face":
            button.SetImageFileNames ("browsing/template_character_characterface-l.tif")                         
        else:
            button.SetImageFileNames ("browsing/template_character_" + i + "-l.tif") 
        button.Hint = i
        
        x = FBAddRegionParam(j*40,FBAttachType.kFBAttachLeft,"")
        y = FBAddRegionParam(0,FBAttachType.kFBAttachBottom,"Characters")
        w = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
        h = FBAddRegionParam(35,FBAttachType.kFBAttachNone,"")
        l.AddRegion(i,i, x, y, w, h)
        l.SetControl(i,button)
        if i == "Actor":
            button.OnClick.Add(actorCallback)
        elif i == "Actor face":
            button.OnClick.Add(actorFaceCallback)
        elif i == "Character":
            button.OnClick.Add(characterCallback)
        elif i == "Character Extension":
            button.OnClick.Add(characterExtensionCallback)
        else:
            button.OnClick.Add(characterFaceCallback)                        
        j = j+1    
    
    tab.Add("Characters",l) # Actually adds the tab you have just layed out to the UI
    
    tab.SetContent(0) # This sets which tab will be the default one open.    
    tab.TabPanel.TabStyle = 0 # tab style

def CreateTool():
    # Tool creation will serve as the hub for all other controls
    t = FBCreateUniqueTool("ADN Handy Shelf")
    t.StartSizeX = 500
    t.StartSizeY = 95    
    PopulateLayout(t)
    ShowTool(t)

CreateTool()
