from pyfbsdk import *
from pyfbsdk_additions import *
from sys import *
import os
import traceback


#There would need to be more error handling added if an unperfect shot track definition files were added.

def PopulateLayout(mainLyt):
    #1.  Creating the instruction title
    l = FBLabel()
    l.Caption = "Select the shot track definition file to use:"
    l.Style = FBTextStyle.kFBTextStyleBold
    l.WordWrap = True    

    x = FBAddRegionParam(5,FBAttachType.kFBAttachLeft,"") # Create a label that is left justify 
    y = FBAddRegionParam(5,FBAttachType.kFBAttachTop,"") # ... and at the top of the layout. 
    w = FBAddRegionParam(300,FBAttachType.kFBAttachNone,"") # its width is fixed at 300 pixels
    h = FBAddRegionParam(20,FBAttachType.kFBAttachNone,"") # and its height is fixed at 15 pixels

    mainLyt.AddRegion("lab","lab", x, y, w, h)
    mainLyt.SetControl("lab",l)

    #2.  Creating a temp button for a place holder
    e = FBEdit()
    e.ReadOnly = True
    e.Text = "" 
    
    x2 = FBAddRegionParam(5,FBAttachType.kFBAttachLeft,"")
    y2 = FBAddRegionParam(5,FBAttachType.kFBAttachBottom,"lab")
    w2 = FBAddRegionParam(220,FBAttachType.kFBAttachNone,"")
    h2 = FBAddRegionParam(20,FBAttachType.kFBAttachNone,"")
    
    mainLyt.AddRegion("path","path", x2, y2, w2, h2)
    mainLyt.SetControl("path",e)
    
    #3.  Creating a the browse button
    b2 = FBButton()
    b2.Caption = "Browse..."
    b2.Justify = FBTextJustify.kFBTextJustifyCenter
    
    x3 = FBAddRegionParam(225,FBAttachType.kFBAttachLeft,"path")
    y3 = FBAddRegionParam(5,FBAttachType.kFBAttachBottom,"lab")
    w3 = FBAddRegionParam(57,FBAttachType.kFBAttachNone,"")
    h3 = FBAddRegionParam(20,FBAttachType.kFBAttachNone,"")
    
    mainLyt.AddRegion("but","but", x3, y3, w3, h3)
    mainLyt.SetControl("but",b2)
        
    #4. Creating the 'create backplate' checkbox
    cb = FBButton()
    cb.Style = FBButtonStyle.kFBCheckbox 
    cb.Caption = "Add backplates to each shot"
    
    x4 = FBAddRegionParam(60, FBAttachType.kFBAttachLeft, "")
    y4 = FBAddRegionParam(5, FBAttachType.kFBAttachBottom, "path")
    w4 = FBAddRegionParam(300,FBAttachType.kFBAttachNone,"")
    h4 = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
      
    mainLyt.AddRegion("backp", "backp",x4,y4,w4,h4)
    mainLyt.SetControl("backp",cb)
    
    #5. Creating the button the automatically does everything
    b3 = FBButton()
    b3.Caption = "Setup Shots"
    b3.Justify = FBTextJustify.kFBTextJustifyCenter
    
    x5 = FBAddRegionParam(40,FBAttachType.kFBAttachLeft,"")
    y5 = FBAddRegionParam(5,FBAttachType.kFBAttachBottom,"backp")
    w5 = FBAddRegionParam(100,FBAttachType.kFBAttachNone,"")
    h5 = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
    
    mainLyt.AddRegion("shots","shots", x5, y5, w5, h5)
    mainLyt.SetControl("shots",b3)

    x6 = FBAddRegionParam(20,FBAttachType.kFBAttachRight,"shots")
    y6 = FBAddRegionParam(5,FBAttachType.kFBAttachBottom,"backp")
    w6 = FBAddRegionParam(100,FBAttachType.kFBAttachNone,"")
    h6 = FBAddRegionParam(25,FBAttachType.kFBAttachNone,"")
        
def CreateRegionShotTool():
    # Tool creation will serve as the hub for all other controls
    global t
    t = FBCreateUniqueTool("Region Shot Track Setup Tool")
    t.StartSizeX = 300
    t.StartSizeY = 143
    
    PopulateLayout(t)
    ShowTool(t)

CreateRegionShotTool()
