from pyfbsdk import *
from pyfbsdk_additions import *
from sys import *
import os
import traceback


#There would need to be more error handling added if an unperfect shot track definition files were added.

def PopulateLayout(mainLyt):
    
    VBox = FBVBoxLayout()

    x = FBAddRegionParam(5,FBAttachType.kFBAttachLeft,"") # Create a label that is left justify 
    y = FBAddRegionParam(5,FBAttachType.kFBAttachTop,"") # ... and at the top of the layout. 
    w = FBAddRegionParam(5,FBAttachType.kFBAttachRight,"") # its width is fixed at 300 pixels
    h = FBAddRegionParam(5,FBAttachType.kFBAttachBottom,"") # and its height is fixed at 15 pixels

    mainLyt.AddRegion("main","main", x, y, w, h)
    mainLyt.SetControl("main",VBox)

    #1.  Creating the instruction title
    l = FBLabel()
    l.Caption = "Select the shot track definition file to use:"
    l.Style = FBTextStyle.kFBTextStyleBold
    l.WordWrap = True    
    VBox.Add(l,25, space=5, width=300)
    
    
    HBox = FBHBoxLayout()
    VBox.Add(HBox, 20)
    
    #2.  Creating a temp button for a place holder
    e = FBEdit()
    e.ReadOnly = True
    e.Text = "" 
    HBox.Add(e, 210, height=20)  
    
    #3.  Creating a the browse button
    b2 = FBButton()
    b2.Caption = "Browse..."
    b2.Justify = FBTextJustify.kFBTextJustifyCenter
    
    HBox.Add(b2, 55, space=5, height=20)
    
    #4. Creating the 'create backplate' checkbox
    cb = FBButton()
    cb.Style = FBButtonStyle.kFBCheckbox 
    cb.Caption = "Add backplates to each shot"

    VBox.Add(cb,20, space=5, width=300)
    
    #5. Creating the button the automatically does everything
    b3 = FBButton()
    b3.Caption = "Setup Shots"
    b3.Justify = FBTextJustify.kFBTextJustifyCenter
    
    VBox.Add(b3,25, space=5, width=100)
 
def CreateBoxShotTool():
    # Tool creation will serve as the hub for all other controls
    global t
    t = FBCreateUniqueTool("Box Layout Shot Track Setup Tool")
    t.StartSizeX = 300
    t.StartSizeY = 143
    
    PopulateLayout(t)
    ShowTool(t)

CreateBoxShotTool()
