from pyfbsdk import *
from pyfbsdk_additions import *
from sys import *
import os
import traceback


#There would need to be more error handling added if an unperfect shot track definition files were added.

def PopulateLayout(mainLyt):
    grid = FBGridLayout()
    x = FBAddRegionParam(5,FBAttachType.kFBAttachLeft,"") # Create a label that is left justify 
    y = FBAddRegionParam(5,FBAttachType.kFBAttachTop,"") # ... and at the top of the layout. 
    w = FBAddRegionParam(5,FBAttachType.kFBAttachRight,"") # its width is fixed at 300 pixels
    h = FBAddRegionParam(5,FBAttachType.kFBAttachBottom,"") # and its height is fixed at 15 pixels

    mainLyt.AddRegion("main","main", x, y, w, h)
   
    mainLyt.SetControl("main", grid)
    

    #1.  Creating the instruction title
    l = FBLabel()
    l.Caption = "Select the shot track definition file to use:"
    l.Style = FBTextStyle.kFBTextStyleBold
    l.WordWrap = True   
    grid.Add(l,0,0, height = 40)
    
    
    #2.  Creating a temp button for a place holder
    e = FBEdit()
    e.ReadOnly = True
    e.Text = "" 
    grid.Add(e,1,0, width = 200, height = 20)
    
    #3.  Creating a the browse button
    b2 = FBButton()
    b2.Caption = "Browse..."
    b2.Justify = FBTextJustify.kFBTextJustifyCenter
    grid.Add(b2,1,1, width = 57, height = 20)
     
    #4. Creating the 'create backplate' checkbox
    cb = FBButton()
    cb.Style = FBButtonStyle.kFBCheckbox 
    cb.Caption = "Add backplates to each shot"
    grid.Add(cb,2,0, width = 200, height = 20)
     
    
    #5. Creating the button the automatically does everything
    b3 = FBButton()
    b3.Caption = "Setup Shots"
    b3.Justify = FBTextJustify.kFBTextJustifyCenter
    grid.Add(b3,3,0, width = 100, height = 20)
 
def CreateGridShotTool():
    # Tool creation will serve as the hub for all other controls
    global t
    t = FBCreateUniqueTool("Grid Layout Shot Track Setup Tool")
    t.StartSizeX = 300
    t.StartSizeY = 175
    PopulateLayout(t)
    ShowTool(t)

CreateGridShotTool()
