from pyfbsdk import *

#Helper function adds a joint to the template - By Jason Parks
def addJointToCharacter ( characterObject, slot, jointName ):
    myJoint = FBFindModelByName(jointName)
    property = characterObject.PropertyList.Find(slot + "Link")
    property.append (myJoint)
    
#List to populate character template
lScene = FBSystem().Scene
lCharacter = FBCharacter ("Grem")
plist = ["Hips", "Hips_LeftUpLeg", "Hips_LeftLeg", "LeftFoot", "Hips_RightUpLeg",
    "Hips_RightLeg", "RightFoot", "Spine", "LeftArm", "LeftForeArm", "LeftHand", 
    "RightArm", "RightForeArm", "RightHand", "Head"]
plonglist = list()
for item in plist:
    plonglist.append(""+item)

#Create character 
addJointToCharacter (lCharacter, 'Hips', plonglist[0])
addJointToCharacter (lCharacter, 'LeftUpLeg', plonglist[1])
addJointToCharacter (lCharacter, 'LeftLeg', plonglist[2])
addJointToCharacter (lCharacter, 'LeftFoot', plonglist[3])
addJointToCharacter (lCharacter, 'RightUpLeg', plonglist[4])
addJointToCharacter (lCharacter, 'RightLeg', plonglist[5])
addJointToCharacter (lCharacter, 'RightFoot', plonglist[6])
addJointToCharacter (lCharacter, 'Spine', plonglist[7])
addJointToCharacter (lCharacter, 'LeftArm', plonglist[8])
addJointToCharacter (lCharacter, 'LeftForeArm', plonglist[9])
addJointToCharacter (lCharacter, 'LeftHand', plonglist[10])
addJointToCharacter (lCharacter, 'RightArm', plonglist[11])
addJointToCharacter (lCharacter, 'RightForeArm', plonglist[12])
addJointToCharacter (lCharacter, 'RightHand', plonglist[13])
addJointToCharacter (lCharacter, 'Head', plonglist[14])
lCharacter.SetCharacterizeOn(True)

#Create Control rig and use it to create animation on Gremlin
lCharacter.CreateControlRig(True)
lScene.Characters[0].InputType = FBCharacterInputType.kFBCharacterInputMarkerSet
lScene.Characters[0].Active = True

#Retargetting: Use another character to create animation on Gremlin
lCharacter.InputCharacter = lScene.Characters[1]
lScene.Characters[0].InputType = FBCharacterInputType.kFBCharacterInputCharacter
lScene.Characters[0].Active = True

