from pyfbsdk import *


#print out all the pose name in current scene

for lComp in FBSystem().Scene.Components: 
    if lComp != None and lComp.Is(FBPose_TypeInfo()): 
        print lComp.Name 
        
        
#Paste pose with pose options FBCharacterPoseOptions
poseName = "Walk"
lApplication = FBApplication()            
lScene = FBSystem().Scene
lSelectedCharacterList = []

for lChars in lScene.Characters:
    if lChars.Selected:
        lSelectedCharacterList.append( lChars )
    
if len( lSelectedCharacterList ) == 0:    
    lSelectedCharacterList.append( lApplication.CurrentCharacter )

for lCharacter in lSelectedCharacterList:
    # set pose options 
    poseOptions = FBCharacterPoseOptions()
    
    poseOptions.mCharacterPoseKeyingMode = FBCharacterPoseKeyingMode.kFBCharacterPoseKeyingModeFullBody
    poseOptions.SetFlag(FBCharacterPoseFlag.kFBCharacterPoseMirror, True)
    poseOptions.mMirrorPlaneType = FBMirrorPlaneType.kFBMirrorPlaneTypeZY  # mirror plane option


for pose in lScene.CharacterPoses:
    if pose.Name == poseName:
        #found our pose
        targetPose = FBCharacterPose(pose.Name)

        print "found targetPose: '%s' in scene" % targetPose.Name

        #Pasting
        targetPose.PastePose(lCharacter, poseOptions )
