# The script demonstrates the problem that even after you update the values
# of animation node, sometimes you do not get updated values from the properties.

from pyfbsdk import *

lCube = FBFindModelByLabelName('Cube')

lCube.Translation = FBVector3d(10,20,30)
ltrans = lCube.Translation
print "Cube Translation: %f,%f,%f" % (ltrans[0], ltrans[1], ltrans[2])
# The print out value will still be the old value if you execute the above line
# together.


# The more reliable way to read back values is through FCurve
lTime = FBTime(0,0,0,0)
lCube.Translation.SetAnimated(True)
lAnimationNode = lCube.Translation.GetAnimationNode()
lPositionV = FBVector3d(
    lAnimationNode.Nodes[0].FCurve.Evaluate(lTime),
    lAnimationNode.Nodes[1].FCurve.Evaluate(lTime),
    lAnimationNode.Nodes[2].FCurve.Evaluate(lTime))
print "current translation is %f,%f,%f" % (lPositionV[0], lPositionV[1], lPositionV[2])
